/*
 ******************************************************************************
 * Copyright (c) 2016, The Linux Foundation. All rights reserved.
 * Permission to use, copy, modify, and/or distribute this software for
 * any purpose with or without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all copies.
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
 * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * ****************************************************************************
 */

/*
 * GRE Tunnel session debug statistic counters
 */
enum nss_stats_gre_tunnel_session {
	NSS_STATS_GRE_TUNNEL_SESSION_RX_PKTS,
	NSS_STATS_GRE_TUNNEL_SESSION_TX_PKTS,
	NSS_STATS_GRE_TUNNEL_SESSION_RX_DROPPED,
	NSS_STATS_GRE_TUNNEL_SESSION_RX_MALFORMED,
	NSS_STATS_GRE_TUNNEL_SESSION_RX_INVALID_PROT,
	NSS_STATS_GRE_TUNNEL_SESSION_DECAP_QUEUE_FULL,
	NSS_STATS_GRE_TUNNEL_SESSION_RX_SINGLE_REC_DGRAM,
	NSS_STATS_GRE_TUNNEL_SESSION_RX_INVALID_REC_DGRAM,
	NSS_STATS_GRE_TUNNEL_SESSION_BUFFER_ALLOC_FAIL,
	NSS_STATS_GRE_TUNNEL_SESSION_BUFFER_COPY_FAIL,
	NSS_STATS_GRE_TUNNEL_SESSION_OUTFLOW_QUEUE_FULL,
	NSS_STATS_GRE_TUNNEL_SESSION_RX_DROPPED_HROOM,
	NSS_STATS_GRE_TUNNEL_SESSION_RX_CBUFFER_ALLOC_FAIL,
	NSS_STATS_GRE_TUNNEL_SESSION_RX_CENQUEUE_FAIL,
	NSS_STATS_GRE_TUNNEL_SESSION_RX_DECRYPT_DONE,
	NSS_STATS_GRE_TUNNEL_SESSION_RX_FORWARD_ENQUEUE_FAIL,
	NSS_STATS_GRE_TUNNEL_SESSION_TX_CBUFFER_ALLOC_FAIL,
	NSS_STATS_GRE_TUNNEL_SESSION_TX_CENQUEUE_FAIL,
	NSS_STATS_GRE_TUNNEL_SESSION_RX_DROPPED_TROOM,
	NSS_STATS_GRE_TUNNEL_SESSION_TX_FORWARD_ENQUEUE_FAIL,
	NSS_STATS_GRE_TUNNEL_SESSION_TX_CIPHER_DONE,
	NSS_STATS_GRE_TUNNEL_SESSION_CRYPTO_NOSUPP,
	NSS_STATS_GRE_TUNNEL_SESSION_RX_DROPPED_MH_VERSION,
	NSS_STATS_GRE_TUNNEL_SESSION_MAX,
};

/*
 * GRE Tunnel session debug statistics
 */
struct nss_stats_gre_tunnel_session_debug {
	uint64_t stats[NSS_STATS_GRE_TUNNEL_SESSION_MAX];
	int32_t if_index;
	uint32_t if_num; /* nss interface number */
	bool valid;
};

/*
 * Stats APIs provided by nss_gre_tunnel.c
 */
extern void nss_gre_tunnel_session_debug_stats_get(struct nss_stats_gre_tunnel_session_debug *s);
